/*
 * lib=LOGREP env=LOGREP lib_prefix= api_prefix=
 * @file
 * File definition
 *
 * This file was created from .spec file of same name, using dlmagic script
 * - if you need to edit it, edit .spec file instad, and use [make filename.c]
 * to re-create it.
 *
 * @todo Add Doxygen comments to file
 * @todo Take the prototypes here declared. See if the functions are static
 * or to be externally seen
 * @todo Doxygen comments to add to functions
 */

/*******************************************************************
* (c) 1997-2005 Aubit Computing Ltd.
*
*
********************************************************************/


#include "a4gl_libaubit4gl_int.h"

#ifdef DEBUG
#ifndef DEBUG_SPEC
#define DEBUG_SPEC
#endif
#endif
static void *libptr=0;
static void clrcachedptrs(void);
void A4GLLOGREP_clrlibptr (void);
int dlclose (void *__handle);

typedef void(*x_func_1)(void *  ,void *  ,int );
static x_func_1 func_1=0;
typedef void(*x_func_2)(void *  );
static x_func_2 func_2=0;
typedef void(*x_func_3)(void *  ,void *  ,void *  ,int );
static x_func_3 func_3=0;
typedef void(*x_func_4)(void *  ,int ,int ,void *  ,void *  );
static x_func_4 func_4=0;
typedef void(*x_func_5)(void *  ,int ,void *  ,void *  );
static x_func_5 func_5=0;
typedef int(*x_func_6)(void *  ,FILE *  ,void *  ,int );
static x_func_6 func_6=0;
typedef int(*x_func_7)(void *  ,FILE *  ,void *  ,int );
static x_func_7 func_7=0;
typedef int(*x_func_8)(void *  ,FILE *  ,FILE *  );
static x_func_8 func_8=0;
typedef void(*x_func_9)(void *  );
static x_func_9 func_9=0;
/**
 * Library init function.
 *
 * @todo : explain ussage and parameters.
 * @return .
 */

static char currentLib[512]="";
void A4GLLOGREP_clrlibptr (void) {
    if (libptr) {dlclose(libptr);}
    libptr=0;
    strcpy(currentLib,"");
    clrcachedptrs();
}

int A4GLLOGREP_initlib (void) {
typedef int (*x_func)(void);
static x_func func=0;
   char *newlib;
   newlib=acl_getenv("LOGREP");
   if (strcmp(newlib,currentLib)!=0) {A4GLLOGREP_clrlibptr ();}
   libptr=(void *)A4GL_dl_openlibrary("LOGREP",newlib);
   if (libptr==0) {
      A4GL_exitwith("Unable to open LOGREP library...");
      return 0;
   }
   strcpy(currentLib, newlib);
   func=(x_func)A4GL_find_func_allow_missing(libptr,"LOGREP_initlib");

   if (func)
      return func();
   else
      return 1;
}


#include "API_layout.h"
void LR_default_file(void* report,void* rbx,int rbs) {
#ifdef DEBUG_SPEC
A4GL_debug("Call to void LR_default_file(%p,%p,%d)\n",report,rbx,rbs);
#endif
   if (libptr==0) A4GLLOGREP_initlib();
   if (func_1==0 || A4GL_never_dlmagic_cache("LR_default_file")) {
        func_1=(x_func_1)A4GL_find_func(libptr,"LR_default_file");
   }
   func_1(report,rbx,rbs);
}

void LR_preview_file(void* report) {
#ifdef DEBUG_SPEC
A4GL_debug("Call to void LR_preview_file(%p)\n",report);
#endif
   if (libptr==0) A4GLLOGREP_initlib();
   if (func_2==0 || A4GL_never_dlmagic_cache("LR_preview_file")) {
        func_2=(x_func_2)A4GL_find_func(libptr,"LR_preview_file");
   }
   func_2(report);
}

void LR_show_layout_rest(void* report,void* vbox,void* rbx,int rbs) {
#ifdef DEBUG_SPEC
A4GL_debug("Call to void LR_show_layout_rest(%p,%p,%p,%d)\n",report,vbox,rbx,rbs);
#endif
   if (libptr==0) A4GLLOGREP_initlib();
   if (func_3==0 || A4GL_never_dlmagic_cache("LR_show_layout_rest")) {
        func_3=(x_func_3)A4GL_find_func(libptr,"LR_show_layout_rest");
   }
   func_3(report,vbox,rbx,rbs);
}

void LR_setup_entry(void* report,int b,int e,void* evt,void* label) {
#ifdef DEBUG_SPEC
A4GL_debug("Call to void LR_setup_entry(%p,%d,%d,%p,%p)\n",report,b,e,evt,label);
#endif
   if (libptr==0) A4GLLOGREP_initlib();
   if (func_4==0 || A4GL_never_dlmagic_cache("LR_setup_entry")) {
        func_4=(x_func_4)A4GL_find_func(libptr,"LR_setup_entry");
   }
   func_4(report,b,e,evt,label);
}

void LR_setup_block(void* report,int b,void* evt,void* label) {
#ifdef DEBUG_SPEC
A4GL_debug("Call to void LR_setup_block(%p,%d,%p,%p)\n",report,b,evt,label);
#endif
   if (libptr==0) A4GLLOGREP_initlib();
   if (func_5==0 || A4GL_never_dlmagic_cache("LR_setup_block")) {
        func_5=(x_func_5)A4GL_find_func(libptr,"LR_setup_block");
   }
   func_5(report,b,evt,label);
}

int LR_save_file(void* report,FILE* fout,void* rbx,int rbs) {
int rval;
#ifdef DEBUG_SPEC
A4GL_debug("Call to int LR_save_file(%p,%p,%p,%d)\n",report,fout,rbx,rbs);
#endif
   if (libptr==0) A4GLLOGREP_initlib();
   if (func_6==0 || A4GL_never_dlmagic_cache("LR_save_file")) {
        func_6=(x_func_6)A4GL_find_func(libptr,"LR_save_file");
   }
   rval=(int)func_6 (report,fout,rbx,rbs);
#ifdef DEBUG_SPEC
A4GL_debug("Returning '%d'",rval);
#endif
return rval;
}

int LR_load_file(void* report,FILE* fin,void* rbx,int rbs) {
int rval;
#ifdef DEBUG_SPEC
A4GL_debug("Call to int LR_load_file(%p,%p,%p,%d)\n",report,fin,rbx,rbs);
#endif
   if (libptr==0) A4GLLOGREP_initlib();
   if (func_7==0 || A4GL_never_dlmagic_cache("LR_load_file")) {
        func_7=(x_func_7)A4GL_find_func(libptr,"LR_load_file");
   }
   rval=(int)func_7 (report,fin,rbx,rbs);
#ifdef DEBUG_SPEC
A4GL_debug("Returning '%d'",rval);
#endif
return rval;
}

int LR_process_file(void* report,FILE* fout,FILE* filter) {
int rval;
#ifdef DEBUG_SPEC
A4GL_debug("Call to int LR_process_file(%p,%p,%p)\n",report,fout,filter);
#endif
   if (libptr==0) A4GLLOGREP_initlib();
   if (func_8==0 || A4GL_never_dlmagic_cache("LR_process_file")) {
        func_8=(x_func_8)A4GL_find_func(libptr,"LR_process_file");
   }
   rval=(int)func_8 (report,fout,filter);
#ifdef DEBUG_SPEC
A4GL_debug("Returning '%d'",rval);
#endif
return rval;
}

void LR_setup_callback(void* ptr) {
#ifdef DEBUG_SPEC
A4GL_debug("Call to void LR_setup_callback(%p)\n",ptr);
#endif
   if (libptr==0) A4GLLOGREP_initlib();
   if (func_9==0 || A4GL_never_dlmagic_cache("LR_setup_callback")) {
        func_9=(x_func_9)A4GL_find_func(libptr,"LR_setup_callback");
   }
   func_9(ptr);
}

static void clrcachedptrs(void) {
   func_1=NULL;
   func_2=NULL;
   func_3=NULL;
   func_4=NULL;
   func_5=NULL;
   func_6=NULL;
   func_7=NULL;
   func_8=NULL;
   func_9=NULL;
}
