/*
 * lib=LOGREPPROC env=LOGREP lib_prefix= api_prefix=
 * @file
 * File definition
 *
 * This file was created from .spec file of same name, using dlmagic script
 * - if you need to edit it, edit .spec file instad, and use [make filename.c]
 * to re-create it.
 *
 * @todo Add Doxygen comments to file
 * @todo Take the prototypes here declared. See if the functions are static
 * or to be externally seen
 * @todo Doxygen comments to add to functions
 */

/*******************************************************************
* (c) 1997-2005 Aubit Computing Ltd.
*
*
********************************************************************/


#include "process.h"

#ifdef DEBUG
#ifndef DEBUG_SPEC
#define DEBUG_SPEC
#endif
#endif
static void *libptr=0;
static void clrcachedptrs(void);
void A4GLLOGREPPROC_clrlibptr (void);
int dlclose (void *__handle);

typedef int(*x_func_1)(void *  ,char *  ,void *  ,int );
static x_func_1 func_1=0;
typedef int(*x_func_2)(void *  ,FILE *  );
static x_func_2 func_2=0;
typedef int(*x_func_3)(FILE *  ,FILE *  );
static x_func_3 func_3=0;
typedef int(*x_func_4)(FILE *  ,FILE *  );
static x_func_4 func_4=0;
typedef int(*x_func_5)(void *  ,char *  ,void *  ,int );
static x_func_5 func_5=0;
/**
 * Library init function.
 *
 * @todo : explain ussage and parameters.
 * @return .
 */

static char currentLib[512]="";
void A4GLLOGREPPROC_clrlibptr (void) {
    if (libptr) {dlclose(libptr);}
    libptr=0;
    strcpy(currentLib,"");
    clrcachedptrs();
}

int A4GLLOGREPPROC_initlib (void) {
typedef int (*x_func)(void);
static x_func func=0;
   char *newlib;
   newlib=acl_getenv("LOGREP");
   if (strcmp(newlib,currentLib)!=0) {A4GLLOGREPPROC_clrlibptr ();}
   libptr=(void *)A4GL_dl_openlibrary("LOGREPPROC",newlib);
   if (libptr==0) {
      A4GL_exitwith("Unable to open LOGREPPROC library...");
      return 0;
   }
   strcpy(currentLib, newlib);
   func=(x_func)A4GL_find_func_allow_missing(libptr,"LOGREPPROC_initlib");

   if (func)
      return func();
   else
      return 1;
}


int RP_default_file(void* report,char* errbuff,void* rbx,int rbs) {
int rval;
#ifdef DEBUG_SPEC
A4GL_debug("Call to int RP_default_file(%p,(%s)),%p,%d)\n",report,A4GL_null_as_null(errbuff),rbx,rbs);
#endif
   if (libptr==0) A4GLLOGREPPROC_initlib();
   if (func_1==0 || A4GL_never_dlmagic_cache("RP_default_file")) {
        func_1=(x_func_1)A4GL_find_func(libptr,"RP_default_file");
   }
   rval=(int)func_1 (report,errbuff,rbx,rbs);
#ifdef DEBUG_SPEC
A4GL_debug("Returning '%d'",rval);
#endif
return rval;
}

int RP_load_file(void* report,FILE* fin) {
int rval;
#ifdef DEBUG_SPEC
A4GL_debug("Call to int RP_load_file(%p,%p)\n",report,fin);
#endif
   if (libptr==0) A4GLLOGREPPROC_initlib();
   if (func_2==0 || A4GL_never_dlmagic_cache("RP_load_file")) {
        func_2=(x_func_2)A4GL_find_func(libptr,"RP_load_file");
   }
   rval=(int)func_2 (report,fin);
#ifdef DEBUG_SPEC
A4GL_debug("Returning '%d'",rval);
#endif
return rval;
}

int RP_dump_file(FILE* fin,FILE* fout) {
int rval;
#ifdef DEBUG_SPEC
A4GL_debug("Call to int RP_dump_file(%p,%p)\n",fin,fout);
#endif
   if (libptr==0) A4GLLOGREPPROC_initlib();
   if (func_3==0 || A4GL_never_dlmagic_cache("RP_dump_file")) {
        func_3=(x_func_3)A4GL_find_func(libptr,"RP_dump_file");
   }
   rval=(int)func_3 (fin,fout);
#ifdef DEBUG_SPEC
A4GL_debug("Returning '%d'",rval);
#endif
return rval;
}

int RP_import_file(FILE* fin,FILE* fout) {
int rval;
#ifdef DEBUG_SPEC
A4GL_debug("Call to int RP_import_file(%p,%p)\n",fin,fout);
#endif
   if (libptr==0) A4GLLOGREPPROC_initlib();
   if (func_4==0 || A4GL_never_dlmagic_cache("RP_import_file")) {
        func_4=(x_func_4)A4GL_find_func(libptr,"RP_import_file");
   }
   rval=(int)func_4 (fin,fout);
#ifdef DEBUG_SPEC
A4GL_debug("Returning '%d'",rval);
#endif
return rval;
}

int RP_process_report(void* report,char* buff,void* rbx,int rbs) {
int rval;
#ifdef DEBUG_SPEC
A4GL_debug("Call to int RP_process_report(%p,(%s)),%p,%d)\n",report,A4GL_null_as_null(buff),rbx,rbs);
#endif
   if (libptr==0) A4GLLOGREPPROC_initlib();
   if (func_5==0 || A4GL_never_dlmagic_cache("RP_process_report")) {
        func_5=(x_func_5)A4GL_find_func(libptr,"RP_process_report");
   }
   rval=(int)func_5 (report,buff,rbx,rbs);
#ifdef DEBUG_SPEC
A4GL_debug("Returning '%d'",rval);
#endif
return rval;
}

static void clrcachedptrs(void) {
   func_1=NULL;
   func_2=NULL;
   func_3=NULL;
   func_4=NULL;
   func_5=NULL;
}
